#include "CppUTest/TestHarness.h"
#include "CppUTestExt/MockSupport.h"

extern "C"
{
#include "add.h"
}

#define OK 1

TEST_GROUP(Add)
{
    static int mock_send_serial(int value) {
        return mock().actualCall("send_serial").withParameter("value",value).returnValue().getIntValue();
    }
    
    void setup()
    {
        UT_PTR_SET(send_serial,&mock_send_serial);
    }
    void teardown()
    {
    }
};

TEST(Add, simple_case)
{
    
    LONGS_EQUAL(2,add(1,1));
}

TEST(Add, send_added_result)
{
    mock().expectOneCall("send_serial").withParameter("value",7).andReturnValue(OK);
    send_added_result(3,4);
}
